#include <stdio.h>
#include <string.h>

void init_table(void);
int  GetTextLine(FILE*, int, char[]);

char* table[30][256];

void main(void)
{
   FILE* rom;
   char  tLine[256];

   init_table();

   rom = fopen("ebtest.smc", "rb");

   GetTextLine(rom, 0xc51b12, tLine);

   printf(tLine);

   fclose(rom);
}

int GetTextLine(FILE* rom, int address, char str[])
{
   int   tpointer;
   int   index = 0;
   char  ch = 0;
   char  prev_ch = 0;
   char* ptr;

   tpointer = address - 0xc00000;
   tpointer += 0x200;

   printf("0x%X\n\n", tpointer);

   fseek(rom, tpointer, SEEK_SET);

   while (ch != 2)
   {
      ch = fgetc(rom);

      if ((ch >= 21) && (ch <= 23))
      {
         prev_ch = ch;
         ch = fgetc(rom);

         ptr = table[prev_ch][ch];
         printf("%s\n", ptr);
      }
      else
      {
         if (table[0][ch][0] != '\0')
            ptr = table[0][ch];
         else
            ptr = "\0";

         printf("%s\n", ptr);
      }

      if (index + strlen(ptr) > 255)
      {
         str[index] = '\0';

         return 1;
      }
      else if (ptr[0] != '\0')
      {
         strcat(str, ptr);
         index += strlen(ptr);
      }
   }

   strcat(str, "\0");
         
   return 1;
}


void init_table(void)
{
   int j;
   int k;

   for (j = 0; j < 30; j++)
      for (k = 0; k < 256; k++)
         table[j][k] = "\0";

//   table[0][0]   = "\n";
//   table[0][1]   = "\n";
//   table[0][2]   = "\n";
//   table[0][3]   = "";
//   table[0][19]  = "";

   table[0][27]  = "<cost>";  // 4 follows, then usually a dollar sign
   table[0][28]  = "<item>";

   table[0][80]  = " ";
   table[0][81]  = "!";
   table[0][82]  = "\"";
   table[0][83]  = "#";
   table[0][84]  = "$";
   table[0][85]  = "%";
   table[0][86]  = "&";
   table[0][87]  = "'";
   table[0][88]  = "(";
   table[0][89]  = ")";
   table[0][90]  = "*";
   table[0][91]  = "+";
   table[0][92]  = ",";
   table[0][93]  = "-";
   table[0][94]  = ".";
   table[0][95]  = "/";
   table[0][96]  = "0";
   table[0][97]  = "1";
   table[0][98]  = "2";
   table[0][99]  = "3";
   table[0][100] = "4";
   table[0][101] = "5";
   table[0][102] = "6";
   table[0][103] = "7";
   table[0][104] = "8";
   table[0][105] = "9";
   table[0][106] = ":";
   table[0][107] = ";";
   table[0][108] = "";
   table[0][109] = "=";
   table[0][110] = "";
   table[0][111] = "?";
   table[0][112] = "*";

   table[0][113] = "A";
   table[0][114] = "B";
   table[0][115] = "C";
   table[0][116] = "D";
   table[0][117] = "E";
   table[0][118] = "F";
   table[0][119] = "G";
   table[0][120] = "H";
   table[0][121] = "I";
   table[0][122] = "J";
   table[0][123] = "K";
   table[0][124] = "L";
   table[0][125] = "M";
   table[0][126] = "N";
   table[0][127] = "O";
   table[0][128] = "P";
   table[0][129] = "Q";
   table[0][130] = "R";
   table[0][131] = "S";
   table[0][132] = "T";
   table[0][133] = "U";
   table[0][134] = "V";
   table[0][135] = "W";
   table[0][136] = "X";
   table[0][137] = "Y";
   table[0][138] = "Z";

   table[0][145] = "a";
   table[0][146] = "b";
   table[0][147] = "c";
   table[0][148] = "d";
   table[0][149] = "e";
   table[0][150] = "f";
   table[0][151] = "g";
   table[0][152] = "h";
   table[0][153] = "i";
   table[0][154] = "j";
   table[0][155] = "k";
   table[0][156] = "l";
   table[0][157] = "m";
   table[0][158] = "n";
   table[0][159] = "o";
   table[0][160] = "p";
   table[0][161] = "q";
   table[0][162] = "r";
   table[0][163] = "s";
   table[0][164] = "t";
   table[0][165] = "u";
   table[0][166] = "v";
   table[0][167] = "w";
   table[0][168] = "x";
   table[0][169] = "y";
   table[0][170] = "z";

   table[21][1] = " in the ";
   table[21][2] = " that ";
   table[21][3] = "...";
   table[21][4] = " and ";
   table[21][5] = " this ";
   table[21][6] = " to the ";
   table[21][7] = " about ";
   table[21][8] = " just ";
   table[21][9] = " of the ";
   table[21][10] = " something ";
   table[21][11] = " going to ";
   table[21][12] = " to ";
   table[21][13] = " you have ";
   table[21][14] = " your ";
   table[21][15] = " for ";
   table[21][16] = " you're ";
   table[21][17] = "*You ";
   table[21][18] = " really ";
   table[21][19] = " don't ";
   table[21][20] = "*The ";
   table[21][21] = "e the ";
   table[21][22] = "e you ";
   table[21][23] = "... ";
   table[21][24] = " the ";
   table[21][25] = " will ";
   table[21][26] = "   ...Brick Road";
   table[21][27] = "ing ";
   table[21][28] = " some ";
   table[21][29] = "              ";
   table[21][30] = "*Do you want to ";
   table[21][31] = " like ";
   table[21][32] = "ou don't have ";
   table[21][33] = " is ";
   table[21][34] = " you ";
   table[21][35] = " you";
   table[21][36] = " anything else";
   table[21][37] = " the";
   table[21][38] = " you want to ";
   table[21][39] = " for the ";
   table[21][40] = " friend";
   table[21][41] = " at the ";
   table[21][42] = "ould you like ";
   table[21][43] = " from ";
   table[21][44] = " would ";
   table[21][45] = "he Runaway Five";
   table[21][46] = " with ";
   table[21][47] = " want to ";
   table[21][48] = "*If you ";
   table[21][49] = " you don't ";
   table[21][50] = "s the ";
   table[21][51] = "ed to ";
   table[21][52] = "e...";
   table[21][53] = " something";
   table[21][54] = "t the ";
   table[21][55] = "*...";
   table[21][56] = "*Please ";
   table[21][57] = "'s ";
   table[21][58] = " of your ";
   table[21][59] = "*It's ";
   table[21][60] = "*Thank you ";
   table[21][61] = "*I ";
   table[21][62] = " here.";
   table[21][63] = " in ";
   table[21][64] = "*Do you ";
   table[21][65] = " I'll ";
   table[21][66] = " have ";
   table[21][67] = "e of ";
   table[21][68] = "d you ";
   table[21][69] = "*I'm ";
   table[21][70] = "me to ";
   table[21][71] = "*I don't ";
   table[21][72] = "*Well, ";
   table[21][73] = "*This is ";
   table[21][74] = "ed the ";
   table[21][75] = "*You're ";
   table[21][76] = " for a ";
   table[21][77] = " anything";
   table[21][78] = "ing";
   table[21][79] = " of ";
   table[21][80] = " you should ";
   table[21][81] = " I ";
   table[21][82] = " from the ";
   table[21][83] = "s...";
   table[21][84] = " it's ";
   table[21][85] = " time";
   table[21][86] = "e to ";
   table[21][87] = "ed ";
   table[21][88] = "e of the ";
   table[21][89] = " to you";
   table[21][90] = "n't you ";
   table[21][91] = " again";
   table[21][92] = " for you.";
   table[21][93] = "other ";
   table[21][94] = "ation";
   table[21][95] = " little ";
   table[21][96] = "ing to ";
   table[21][97] = " can't ";
   table[21][98] = " much";
   table[21][99] = " someone ";
   table[21][100] = " on the ";
   table[21][101] = " looks like";
   table[21][102] = " don't you ";
   table[21][103] = " very ";
   table[21][104] = "the ";
   table[21][105] = " can ";
   table[21][106] = "you";
   table[21][107] = " that you ";
   table[21][108] = " it";
   table[21][109] = " you want";
   table[21][110] = "ou can't ";
   table[21][111] = " able to ";
   table[21][112] = " already ";
   table[21][113] = " give you ";
   table[21][114] = "understand";
   table[21][115] = "       ";
   table[21][116] = " my ";
   table[21][117] = " you can ";
   table[21][118] = " that";
   table[21][119] = " what ";
   table[21][120] = "here's ";
   table[21][121] = " there ";
   table[21][122] = "n the ";
   table[21][123] = "*What ";
   table[21][124] = "Thank you";
   table[21][125] = " I can't ";
   table[21][126] = "one";
   table[21][127] = "*The";
   table[21][128] = " thought";
   table[21][129] = " not ";
   table[21][130] = "You should";
   table[21][131] = "ou know";
   table[21][132] = " has ";
   table[21][133] = " back";
   table[21][134] = " of";
   table[21][135] = "ve been ";
   table[21][136] = " I'm ";
   table[21][137] = " there";
   table[21][138] = " with you";
   table[21][139] = "*I heard ";
   table[21][140] = " in";
   table[21][141] = " here ";
   table[21][142] = " Fourside";
   table[21][143] = "I wonder ";
   table[21][144] = " to";
   table[21][145] = " could ";
   table[21][146] = " think ";
   table[21][147] = " out";
   table[21][148] = " good ";
   table[21][149] = "  the ";
   table[21][150] = "  You ";
   table[21][151] = " too much";
   table[21][152] = "ome back";
   table[21][153] = "t...";
   table[21][154] = " here";
   table[21][155] = "thing";
   table[21][156] = "come ";
   table[21][157] = "ly ";
   table[21][158] = "ent";
   table[21][159] = " strong";
   table[21][160] = " money.";
   table[21][161] = "*I'll ";
   table[21][162] = "an ";
   table[21][163] = "ou must ";
   table[21][164] = " are you ";
   table[21][165] = " with the";
   table[21][166] = " on your ";
   table[21][167] = "too many ";
   table[21][168] = " you.";
   table[21][169] = "know";
   table[21][170] = " to be ";
   table[21][171] = " around ";
   table[21][172] = " if you ";
   table[21][173] = "*Are you ";
   table[21][174] = "ome again";
   table[21][175] = "e and ";
   table[21][176] = " more ";
   table[21][177] = "think";
   table[21][178] = "e your ";
   table[21][179] = "*Don't ";
   table[21][180] = "nd the ";
   table[21][181] = "t to ";
   table[21][182] = "rea";
   table[21][183] = " he";
   table[21][184] = " me";
   table[21][185] = " strange";
   table[21][186] = " for you";
   table[21][187] = "ight";
   table[21][188] = " a ";
   table[21][189] = " be";
   table[21][190] = "ther";
   table[21][191] = "all ";
   table[21][192] = " cannot ";
   table[21][193] = "here is ";
   table[21][194] = "You have";
   table[21][195] = "Monotoli";
   table[21][196] = " was ";
   table[21][197] = "ll you ";
   table[21][198] = "hat ";
   table[21][199] = ", but ";
   table[21][200] = " stuff";
   table[21][201] = "eep";
   table[21][202] = " it ";
   table[21][203] = " didn't ";
   table[21][204] = " like th";
   table[21][205] = "ll right";
   table[21][206] = " should";
   table[21][207] = " over";
   table[21][208] = "*Oh, ";
   table[21][209] = " hear";
   table[21][210] = " every";
   table[21][211] = "I'm not ";
   table[21][212] = " about t";
   table[21][213] = " zombies";
   table[21][214] = " damage";
   table[21][215] = "his is ";
   table[21][216] = "all";
   table[21][217] = " some";
   table[21][218] = "*It ";
   table[21][219] = " attack";
   table[21][220] = " right ";
   table[21][221] = "ally ";
   table[21][222] = "orry";
   table[21][223] = "ess";
   table[21][224] = "er ";
   table[21][225] = "*That's ";
   table[21][226] = "carry it";
   table[21][227] = "ake";
   table[21][228] = "t was ";
   table[21][229] = ", the ";
   table[21][230] = "n you ";
   table[21][231] = "sn't ";
   table[21][232] = " help";
   table[21][233] = "king ";
   table[21][234] = "ear";
   table[21][235] = "ing the";
   table[21][236] = "  It's ";
   table[21][237] = "very";
   table[21][238] = " talking";
   table[21][239] = "ou've ";
   table[21][240] = "that's ";
   table[21][241] = " to me";
   table[21][242] = "*Hello";
   table[21][243] = " enemy";
   table[21][244] = " you are";
   table[21][245] = " by ";
   table[21][246] = " IBNT";
   table[21][247] = "ight ";
   table[21][248] = "on't ";
   table[21][249] = "est";
   table[21][250] = "ick";
   table[21][251] = " power ";
   table[21][252] = "s that ";
   table[21][253] = "s are ";
   table[21][254] = " call";
   table[21][255] = "t is ";
   table[22][0] = " is";
   table[22][1] = "age";
   table[22][2] = ", and ";
   table[22][3] = " great ";
   table[22][4] = "*Thanks";
   table[22][5] = " people";
   table[22][6] = "ter";
   table[22][7] = "not";
   table[22][8] = "ill";
   table[22][9] = "ness";
   table[22][10] = "*This ";
   table[22][11] = " into ";
   table[22][12] = " ha";
   table[22][13] = " I can ";
   table[22][14] = "t your ";
   table[22][15] = " before";
   table[22][16] = " things";
   table[22][17] = "tion";
   table[22][18] = " for";
   table[22][19] = "be ";
   table[22][20] = " this";
   table[22][21] = "Happy";
   table[22][22] = "  You";
   table[22][23] = "out";
   table[22][24] = "enough";
   table[22][25] = "  I'm ";
   table[22][26] = "*You";
   table[22][27] = " go";
   table[22][28] = "for";
   table[22][29] = " all th";
   table[22][30] = " though";
   table[22][31] = "ing you";
   table[22][32] = "e you";
   table[22][33] = "ring ";
   table[22][34] = "one ";
   table[22][35] = "get";
   table[22][36] = "t you ";
   table[22][37] = "*I'm s";
   table[22][38] = " the s";
   table[22][39] = "e's ";
   table[22][40] = "port";
   table[22][41] = "d...";
   table[22][42] = " out ";
   table[22][43] = "*What";
   table[22][44] = " get ";
   table[22][45] = "I have ";
   table[22][46] = "looking";
   table[22][47] = "n this ";
   table[22][48] = " of my ";
   table[22][49] = " have a";
   table[22][50] = "ent ";
   table[22][51] = " do";
   table[22][52] = "d of ";
   table[22][53] = "ting";
   table[22][54] = "ncrease";
   table[22][55] = " Twoson";
   table[22][56] = "through";
   table[22][57] = "s your ";
   table[22][58] = "ou'll ";
   table[22][59] = " place";
   table[22][60] = " right";
   table[22][61] = " Onett";
   table[22][62] = "     ";
   table[22][63] = " our ";
   table[22][64] = " too";
   table[22][65] = "ater";
   table[22][66] = " be ";
   table[22][67] = "ain";
   table[22][68] = "ing.";
   table[22][69] = "take ";
   table[22][70] = "e is ";
   table[22][71] = "the";
   table[22][72] = " please";
   table[22][73] = " do you";
   table[22][74] = "need";
   table[22][75] = "use";
   table[22][76] = " now.";
   table[22][77] = " got ";
   table[22][78] = "   ";
   table[22][79] = "and ";
   table[22][80] = "ning";
   table[22][81] = " sta";
   table[22][82] = " the t";
   table[22][83] = "I was ";
   table[22][84] = "y the ";
   table[22][85] = "his";
   table[22][86] = "appe";
   table[22][87] = "con";
   table[22][88] = " ho";
   table[22][89] = "hat's ";
   table[22][90] = "Threed";
   table[22][91] = "get ";
   table[22][92] = "s of ";
   table[22][93] = "inter";
   table[22][94] = "talk";
   table[22][95] = " man";
   table[22][96] = "day";
   table[22][97] = "ove";
   table[22][98] = " ha ha";
   table[22][99] = "inally";
   table[22][100] = "monkey";
   table[22][101] = "s and ";
   table[22][102] = "ate";
   table[22][103] = "see";
   table[22][104] = "town";
   table[22][105] = "side";
   table[22][106] = "y to ";
   table[22][107] = "ever ";
   table[22][108] = "equip";
   table[22][109] = " than";
   table[22][110] = " who";
   table[22][111] = "long";
   table[22][112] = "care";
   table[22][113] = "room";
   table[22][114] = "e are ";
   table[22][115] = "ard";
   table[22][116] = "end";
   table[22][117] = ", you ";
   table[22][118] = " the b";
   table[22][119] = "I know";
   table[22][120] = "think ";
   table[22][121] = "s you ";
   table[22][122] = "time";
   table[22][123] = "ment";
   table[22][124] = " so";
   table[22][125] = "!  ";
   table[22][126] = "I've ";
   table[22][127] = "ell";
   table[22][128] = " wa";
   table[22][129] = "ious";
   table[22][130] = "reat";
   table[22][131] = "live";
   table[22][132] = "ange";
   table[22][133] = " we";
   table[22][134] = "ble";
   table[22][135] = "*.....";
   table[22][136] = "ecover";
   table[22][137] = " only ";
   table[22][138] = "thing ";
   table[22][139] = "er...";
   table[22][140] = "Mr. ";
   table[22][141] = "ough";
   table[22][142] = " now";
   table[22][143] = "  I";
   table[22][144] = "wor";
   table[22][145] = "to ";
   table[22][146] = "ed.";
   table[22][147] = "  I ";
   table[22][148] = "'re ";
   table[22][149] = " give ";
   table[22][150] = "ing a ";
   table[22][151] = "return";
   table[22][152] = "better";
   table[22][153] = "ince ";
   table[22][154] = " well";
   table[22][155] = " one ";
   table[22][156] = "still";
   table[22][157] = "ying ";
   table[22][158] = "me...";
   table[22][159] = "sta";
   table[22][160] = "ust ";
   table[22][161] = "per";
   table[22][162] = "lease";
   table[22][163] = "ling ";
   table[22][164] = "point";
   table[22][165] = "ect";
   table[22][166] = "ast";
   table[22][167] = "pretty";
   table[22][168] = "Giygas";
   table[22][169] = "ecause";
   table[22][170] = "member";
   table[22][171] = "carry ";
   table[22][172] = " used ";
   table[22][173] = "elieve";
   table[22][174] = " money";
   table[22][175] = "pres";
   table[22][176] = "way";
   table[22][177] = " di";
   table[22][178] = " even";
   table[22][179] = "ound ";
   table[22][180] = "s to ";
   table[22][181] = "ting ";
   table[22][182] = "ted ";
   table[22][183] = "oing";
   table[22][184] = " and";
   table[22][185] = "ine";
   table[22][186] = "  T";
   table[22][187] = "sure";
   table[22][188] = " on ";
   table[22][189] = "*...I";
   table[22][190] = "while";
   table[22][191] = "*but ";
   table[22][192] = "*We";
   table[22][193] = "ice";
   table[22][194] = "se ";
   table[22][195] = "ive ";
   table[22][196] = " rea";
   table[22][197] = " com";
   table[22][198] = "est ";
   table[22][199] = "have";
   table[22][200] = " but";
   table[22][201] = "away";
   table[22][202] = "here";
   table[22][203] = " must";
   table[22][204] = " but ";
   table[22][205] = " want";
   table[22][206] = "ready";
   table[22][207] = "I'm";
   table[22][208] = "carr";
   table[22][209] = "my ";
   table[22][210] = "ay...";
   table[22][211] = " are ";
   table[22][212] = "*Hey,";
   table[22][213] = "world";
   table[22][214] = "ing a";
   table[22][215] = " happ";
   table[22][216] = " seem";
   table[22][217] = " his ";
   table[22][218] = "nder";
   table[22][219] = " se";
   table[22][220] = "ant";
   table[22][221] = "item";
   table[22][222] = "*But";
   table[22][223] = " sho";
   table[22][224] = "in a ";
   table[22][225] = "made ";
   table[22][226] = "night";
   table[22][227] = "et's ";
   table[22][228] = " like";
   table[22][229] = "  The";
   table[22][230] = "che";
   table[22][231] = " de";
   table[22][232] = "ful";
   table[22][233] = "hat";
   table[22][234] = "and";
   table[22][235] = "self";
   table[22][236] = "ould";
   table[22][237] = "*No";
   table[22][238] = "car";
   table[22][239] = " tr";
   table[22][240] = " good";
   table[22][241] = " stor";
   table[22][242] = "ombie";
   table[22][243] = "*Oh";
   table[22][244] = "*It";
   table[22][245] = "s a ";
   table[22][246] = "vent";
   table[22][247] = "ant ";
   table[22][248] = " so ";
   table[22][249] = "olla";
   table[22][250] = "ree";
   table[22][251] = "Your ";
   table[22][252] = "make ";
   table[22][253] = " work";
   table[22][254] = "power";
   table[22][255] = " home";
   table[23][0] = "also";
   table[23][1] = "ance";
   table[23][2] = "*How";
   table[23][3] = "h...";
   table[23][4] = "*If";
   table[23][5] = "ple";
   table[23][6] = "buy";
   table[23][7] = "e, ";
   table[23][8] = "n't";
   table[23][9] = "oke";
   table[23][10] = "n't ";
   table[23][11] = "more";
   table[23][12] = "Good";
   table[23][13] = "t a ";
   table[23][14] = " all";
   table[23][15] = "take";
   table[23][16] = "round";
   table[23][17] = " when";
   table[23][18] = " name";
   table[23][19] = "being";
   table[23][20] = "attle";
   table[23][21] = "ite";
   table[23][22] = "ack";
   table[23][23] = "y...";
   table[23][24] = "*Whe";
   table[23][25] = "with";
   table[23][26] = "al ";
   table[23][27] = "have ";
   table[23][28] = " look";
   table[23][29] = "t of ";
   table[23][30] = "aster";
   table[23][31] = " a lo";
   table[23][32] = " feel";
   table[23][33] = "here ";
   table[23][34] = "count";
   table[23][35] = "monst";
   table[23][36] = "now";
   table[23][37] = "ark";
   table[23][38] = "ous";
   table[23][39] = "'ll";
   table[23][40] = " bus";
   table[23][41] = "head";
   table[23][42] = " any ";
   table[23][43] = "t you";
   table[23][44] = "erson";
   table[23][45] = "after";
   table[23][46] = "ummer";
   table[23][47] = " hard";
   table[23][48] = "ful ";
   table[23][49] = "ever";
   table[23][50] = " kid";
   table[23][51] = " a b";
   table[23][52] = "kay";
   table[23][53] = "tra";
   table[23][54] = "pla";
   table[23][55] = "ook";
   table[23][56] = "ome";
   table[23][57] = "eat";
   table[23][58] = "*Wel";
   table[23][59] = " off";
   table[23][60] = "turn";
   table[23][61] = "I am";
   table[23][62] = "oney";
   table[23][63] = " any";
   table[23][64] = "ave";
   table[23][65] = "any ";
   table[23][66] = "enem";
   table[23][67] = " con";
   table[23][68] = " me ";
   table[23][69] = "red";
   table[23][70] = "en ";
   table[23][71] = " bo";
   table[23][72] = " re";
   table[23][73] = "ell ";
   table[23][74] = "sell";
   table[23][75] = "what";
   table[23][76] = "next";
   table[23][77] = "ure";
   table[23][78] = " bu";
   table[23][79] = "pro";
   table[23][80] = " on";
   table[23][81] = "res";
   table[23][82] = "es ";
   table[23][83] = " lo";
   table[23][84] = "our";
   table[23][85] = "use ";
   table[23][86] = "iste";
   table[23][87] = "ood";
   table[23][88] = " no";
   table[23][89] = "ope";
   table[23][90] = "ock";
   table[23][91] = "row";
   table[23][92] = "*He";
   table[23][93] = "how";
   table[23][94] = " may";
   table[23][95] = " as ";
   table[23][96] = "stor";
   table[23][97] = " are";
   table[23][98] = "ost ";
   table[23][99] = "mean";
   table[23][100] = "  We";
   table[23][101] = "  He";
   table[23][102] = "*An";
   table[23][103] = "it ";
   table[23][104] = "in ";
   table[23][105] = "ound";
   table[23][106] = "one.";
   table[23][107] = "come";
   table[23][108] = "blue";
   table[23][109] = "way,";
   table[23][110] = " or ";
   table[23][111] = " mo";
   table[23][112] = ".  ";
   table[23][113] = "each";
   table[23][114] = "some";
   table[23][115] = "*(Th";
   table[23][116] = "otel";
   table[23][117] = "hand";
   table[23][118] = "came";
   table[23][119] = " ca";
   table[23][120] = "ame";
   table[23][121] = "*Hey";
   table[23][122] = "een ";
   table[23][123] = "spec";
   table[23][124] = "red ";
   table[23][125] = "ing!";
   table[23][126] = " ...";
   table[23][127] = "hose";
   table[23][128] = "ind ";
   table[23][129] = "ice ";
   table[23][130] = "ver";
   table[23][131] = "  W";
   table[23][132] = "min";
   table[23][133] = "et ";
   table[23][134] = "on ";
   table[23][135] = "ace";
   table[23][136] = "er.";
   table[23][137] = "are ";
   table[23][138] = "nter";
   table[23][139] = "o...";
   table[23][140] = "were";
   table[23][141] = "help";
   table[23][142] = "old ";
   table[23][143] = " it.";
   table[23][144] = "hear";
   table[23][145] = "stop";
   table[23][146] = "look";
   table[23][147] = "com";
   table[23][148] = "*Do";
   table[23][149] = " her";
   table[23][150] = " pro";
   table[23][151] = "chin";
   table[23][152] = "ble ";
   table[23][153] = "e a ";
   table[23][154] = "girl";
   table[23][155] = "luck";
   table[23][156] = "  B";
   table[23][157] = "act";
   table[23][158] = "ike";
   table[23][159] = "down";
   table[23][160] = "part";
   table[23][161] = " see";
   table[23][162] = " use";
   table[23][163] = "uch ";
   table[23][164] = "from";
   table[23][165] = "just";
   table[23][166] = "llow";
   table[23][167] = "*Her";
   table[23][168] = " at ";
   table[23][169] = "*So,";
   table[23][170] = " ye";
   table[23][171] = "ser";
   table[23][172] = "ying";
   table[23][173] = "ring";
   table[23][174] = "eave";
   table[23][175] = "big ";
   table[23][176] = "ried";
   table[23][177] = " was";
   table[23][178] = " say";
   table[23][179] = " su";
   table[23][180] = "her";
   table[23][181] = "it.";
   table[23][182] = "Man";
   table[23][183] = "kin";
   table[23][184] = " up";
   table[23][185] = "ers";
   table[23][186] = "*Why";
   table[23][187] = "p...";
   table[23][188] = "cour";
   table[23][189] = " him";
   table[23][190] = "agic";
   table[23][191] = "any";
   table[23][192] = "fin";
   table[23][193] = "eal";
   table[23][194] = "he ";
   table[23][195] = "ide";
   table[23][196] = "oor";
   table[23][197] = "ity";
   table[23][198] = "got";
   table[23][199] = "ens";
   table[23][200] = "ish";
   table[23][201] = "ive";
   table[23][202] = " sa";
   table[23][203] = "oon";
   table[23][204] = "fee";
   table[23][205] = "s a";
   table[23][206] = "nce";
   table[23][207] = "  D";
   table[23][208] = "uck";
   table[23][209] = "ass";
   table[23][210] = "man";
   table[23][211] = "a p";
   table[23][212] = "*(I";
   table[23][213] = "*Wh";
   table[23][214] = " gu";
   table[23][215] = "  (";
   table[23][216] = "bus";
   table[23][217] = "los";
   table[23][218] = "ts ";
   table[23][219] = " ba";
   table[23][220] = "  S";
   table[23][221] = " if";
   table[23][222] = "*Ha";
   table[23][223] = " ma";
   table[23][224] = "unn";
   table[23][225] = "ay ";
   table[23][226] = "ner";
   table[23][227] = "*A ";
   table[23][228] = "or ";
   table[23][229] = "stu";
   table[23][230] = "ust";
   table[23][231] = "kya";
   table[23][232] = "shi";
   table[23][233] = "pos";
   table[23][234] = "  A";
   table[23][235] = "int";
   table[23][236] = " le";
   table[23][237] = "ary";
   table[23][238] = "ven";
   table[23][239] = " ch";
   table[23][240] = "own";
   table[23][241] = " hu";
   table[23][242] = "*My";
   table[23][243] = "*So";
   table[23][244] = " sp";
   table[23][245] = " sh";
   table[23][246] = "wan";
   table[23][247] = "ool";
   table[23][248] = "  Y";
   table[23][249] = "old";
   table[23][250] = "eas";
   table[23][251] = ", I";
   table[23][252] = "iki";
   table[23][253] = "*Ky";
   table[23][254] = "*Ye";
   table[23][255] = "spi";

   table[28][1] = "<Party Member>";
   table[28][2] = "<Party Member>";
   table[28][3] = "<Party Member>";
   table[28][4] = "<Party Member>";
}



